DarkRadiant - Compiling in Linux

From The DarkMod Wiki
Revision as of 17:44, 9 August 2021 by Greebo (talk | contribs) (→‎Ubuntu 20.04 and later)
(diff) ← Older revision | Latest revision (diff) | Newer revision → (diff)
Jump to navigationJump to search

Install Required Packages

Ubuntu 20.04 and later

Copy and paste the following into a terminal:

sudo apt-get install git g++ gettext cmake pkg-config zlib1g-dev libjpeg-dev libxml2-dev libsigc++-2.0-dev libgtest-dev libeigen3-dev
sudo apt-get install libwxgtk3.0-gtk3-dev libpng-dev libftgl-dev libglew-dev libalut-dev libvorbis-dev python3-dev libgit2-dev

openSUSE Tumbleweed

Copy and paste the following into a terminal:

sudo zypper install git cmake gcc-c++ gettext-tools zlib-devel libjpeg62-devel libxml2-devel libsigc++2-devel gtest
sudo zypper install wxWidgets-3_0-devel ftgl-devel glew-devel libvorbis-devel freealut-devel python38-devel

Mageia 8

Copy and paste the following into a terminal, run as user who has the required permissions to install the packages:

sudo urpmi git cmake make gcc-c++ libzlib-devel libjpeg-devel libwxgtku3.0-devel libsigc++2.0-devel 
sudo urpmi libftgl-devel libglew-devel libpython3-devel libopenal-devel libfreealut-devel libvorbis-devel lib64gtest-devel

Debian 10

Copy and paste the following into a terminal:

sudo apt-get install git cmake pkg-config gettext zlib1g-dev libjpeg-dev libwxgtk3.0-dev libgtest-dev
sudo apt-get install libxml2-dev libsigc++-2.0-dev libpng-dev libftgl-dev libglew-dev libalut-dev libvorbis-dev python3-dev

Fedora 26 / 25

Copy and paste the following into a terminal:

sudo dnf install git automake libtool gcc-c++ zlib-devel libjpeg-turbo-devel wxGTK3-devel libxml2-devel libsigc++20-devel 
sudo dnf install libpng12-devel ftgl-devel glew-devel libvorbis-devel freealut-devel python-devel pybind11-devel

Note that the wxGTK package does not yet support Wayland environments, which is the default since Fedora 25 (DarkRadiant will just segfault during startup). You'll need to deactivate it for the moment being.

Arch Linux

The following packages are requred after starting from an Anarchy installation using Gnome as Window Manager.

sudo pacman -S cmake wxgtk2 ftgl glew freealut libvorbis python libsigc++ eigen

CentOS 7 x64

Copy and paste the following into a terminal, run as user who has the required permissions to install the packages:

sudo yum -y install gcc gcc-c++ git automake libtool zlib-devel libjpeg-turbo-devel wxGTK3-devel libxml2-devel 
sudo yum -y install libsigc++20-devel ftgl-devel glew-devel boost-devel openal-soft-devel freealut-devel libvorbis-devel python-devel

CentOS 7 ships with an older compiler, so you'll need to install a more recent GCC first (following the directions on stackoverflow):

sudo yum install centos-release-scl 
sudo yum install devtoolset-4-gcc*
scl enable devtoolset-4 bash

Note that the wxGTK3-devel package doesn't create a wx-config symlink in the /usr/bin directory, that's why you need to pass an additional --with-wx-config=/usr/bin/wx-config-3.0 argument to the ./configure script below, like this:

./configure --enable-darkmod-plugins --with-wx-config=/usr/bin/wx-config-3.0

Slackware 14.2

Slackware doesn't provide precompiled packages on the one hand (unlike Debian or Arch), but already ships with a lot of libraries on the other. Stuff like git, automake, libtools and development libraries like zlib and boost are already present, but wxWidgets, openAL, ALut and FTGL need to be installed by means of a SlackBuild script. The following has been done in Slackware 14.2, so your mileage may vary.

Download the Source tarballs and the SlackBuild packages from these URLs:

Download and extract the SlackBuild .tar.gz files in your ~/Downloads folder (or anywhere else where you want to have them). For instance, the wxGTK3 package can be untar'd like this:

tar xzf wxGTK3.tar.gz
cd wxGTK3
chmod +x wxGTK3.SlackBuild

Do this for all of the above libraries, that should give you the directories ftgl/, OpenAL/, wxGTK3/ and freealut/. Next, download the Source Tarballs (the .tar.bz2) files from the links above and place them next to the corresponding SlackBuild script. Then run the scripts for each of them and install the build output in your system in a second step:

./wxGTK3.SlackBuild

This produced (on my end at least) the package /tmp/wxGTK3-3.0.2-i486-2_SBo.tgz which can be installed by the installpkg command:

installpkg /tmp/wxGTK3-3.0.2-i486-2_SBo.tgz

Do the same for the rest of the libraries (ftgl, OpenAL, freealut). Be aware that the freealut package depends on the OpenAL package, so you need to do the OpenAL one first. Once you have these installed, you can proceed to the build section (git clone and configure and make).

Gentoo

DarkRadiant can be built and installed from an unofficial ebuild repository (overlay). The easiest way to do this is with app-portage/layman, which must be installed with the git use flag.

In the 'overlays' section in /etc/layman/layman.cfg, add:

https://raw.githubusercontent.com/varingst/varingst-overlay/master/overlay.xml

Then fetch and add the overlay:

# layman -f -a varingst

Now that the overlay is added, you can build and install DarkRadiant with Portage:

# emerge darkradiant

To sync the overlay, either do it manually with layman:

# layman -s varingst

Or look into the various ways to hook into the portage sync system.

Building with a non-default g++ Compiler

DarkRadiant's codebase makes use of C++17 features, in particular std::filesystem. Not all distributions ship with a compatible g++ compiler by default, but it's possible to install a more recent compiler suite. Get the compiler package and ensure that the makefiles are called with the correct setup, e.g.

CXX="g++-5.1" cmake . && make && make install

Older Distributions / Compiling DarkRadiant 1.8 and older

The instructions about how to compile DR 1.8 (based on GTK) in distributions published in 2012 and older have been removed. They should still be in the history of this page, should they ever be needed.

Obtain the source

Make sure you have the git client installed, this is covered in the package installation commands above. Next, change to the directory where you want the source code to be in and then clone the Git repository with:

git clone git://github.com/codereader/DarkRadiant.git --recurse-submodules

Once the initial clone is done, the source can be updated to the latest version from inside the working directory with:

git pull

Configure and Compile

DarkRadiant employs the CMake build system under Linux as used in many open-source projects. Make sure you have the CMake toolchain downloaded, this is covered in the package installation commands above.

To build DarkRadiant, run the typical chain of CMake and make commands:

cmake .
make
[sudo] make install

By the above, a release build will be created; if a debug build is required pass the -DCMAKE_BUILD_TYPE=Debug option to the cmake command script.

Other points to note about the configure process:

  • The DarkMod-specific plugins are built by default, the -DENABLE_DM_PLUGINS=OFF argument will disable them.
  • The CMake script autodetects required dependencies, and will conditionally enable optional components of DarkRadiant (such as the sound plugin) based on what it finds.
  • For quick testing of a DarkRadiant build, it is desirable to install it into a temporary location rather than the default of /usr/local; for this, simply pass a prefix option such as -DCMAKE_INSTALL_PREFIX=/tmp/dr to cmake, after which DarkRadiant will be installed in /tmp/dr/bin/darkradiant.

Multiprocessor Systems

You can pass the --jobs=N parameter to make:

make --jobs=2

to use more than one processor for the compilation. This will eat lots of RAM, so don't do this on machines with little available memory.

Building a .deb package

To build a Debian/Ubuntu package, simply run

dpkg-buildpackage -rfakeroot

in the main darkradiant directory. The .deb will be created in the parent directory.